/* +---------------------------------------------------------------------------+
   |          The Mobile Robot Programming Toolkit (MRPT) C++ library          |
   |                                                                           |
   |                   http://mrpt.sourceforge.net/                            |
   |                                                                           |
   |   Copyright (C) 2005-2010  University of Malaga                           |
   |                                                                           |
   |    This software was written by the Machine Perception and Intelligent    |
   |      Robotics Lab, University of Malaga (Spain).                          |
   |    Contact: Jose-Luis Blanco  <jlblanco@ctima.uma.es>                     |
   |                                                                           |
   |  This file is part of the MRPT project.                                   |
   |                                                                           |
   |     MRPT is free software: you can redistribute it and/or modify          |
   |     it under the terms of the GNU General Public License as published by  |
   |     the Free Software Foundation, either version 3 of the License, or     |
   |     (at your option) any later version.                                   |
   |                                                                           |
   |   MRPT is distributed in the hope that it will be useful,                 |
   |     but WITHOUT ANY WARRANTY; without even the implied warranty of        |
   |     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         |
   |     GNU General Public License for more details.                          |
   |                                                                           |
   |     You should have received a copy of the GNU General Public License     |
   |     along with MRPT.  If not, see <http://www.gnu.org/licenses/>.         |
   |                                                                           |
   +---------------------------------------------------------------------------+ */

#include <mrpt/hwdrivers.h> // Precompiled header


#if MRPT_HAS_BUMBLEBEE
	#include <PGRFlyCapture.h>
#endif

using namespace mrpt::hwdrivers;


//MRPT_TODO("Crear metodos open() y close() en vez del constructor!")

/*-------------------------------------------------------------
			TCaptureOptions_bumblebee Constructor
 -------------------------------------------------------------*/
TCaptureOptions_bumblebee::TCaptureOptions_bumblebee() :
				frame_width		(640),
				frame_height	(480),
				color			(false),
				getRectified	(true),
#if MRPT_HAS_BUMBLEBEE
				framerate		(FLYCAPTURE_FRAMERATE_15)
#else
				framerate		(15)
#endif
{
}

